;---INT 15-----------------------------------------------14-02-89-------------- 
; CASSETTE I/O 
;       (AH) = 0   (  ᨨ 0  1 -樨 
;       (AH) = 1     ) 
;       (AH) = 2 . 1   256-    
;               (ES,BX) =    
;               (CX) =     
;                : 
;               (ES,BX) =   .  + 1 
;               (DX) =    
;               (CY) = 0      
;                    = 1    
;               (AH) =   ,  (CY)=1 
;                       =01  CRC  
;                       =02   
;                       =04     
;       (AH) = 3  1   256-    
;               (ES,BX) =    
;               (CX) =     
;                : 
;               (EX,BX) =     + 1 
;               (CX) = 0 
;       (AH) = 4     
;              DS:[BX] -   ,    
;              (ES) -    
;               : 
;              (AH) -   ,  (CY) = 1 
;                       =01  CRC  
;                       =02   
;                       =04     
;       (AH) = 5     
;              DS:[BX] -   ,    
;              (ES) -    
;               : 
;              (CY) = 1 -   
;       (AH) =   - (CY)=1 -  , 
;               (AH) = 80 -   . 
;--------------------------------------------------------------------------- 
; 
CASSETTE_IO     PROC        FAR 
        CLI                     ;  
        PUSH    DS 
        PUSH    AX 
	MOV	AX,DATA 
	MOV	DS,AX 
        POP     AX 
        CALL    W1              ;   
        POP     DS 
        STI                     ;  
        RET     2               ; 
CASSETTE_IO     ENDP 
W1      PROC NEAR 
;-----------------------------------------------------------14-02-89-------- 
; : 
;       AH 
; 
;  AH            
;----------------------------------------------------------------------------- 
;  0            .  
;  1            .  
;  2              
;  3              
;  4              
;  5              
;------------------------------------------------------------------------------ 
 
        OR      AH,AH 
        JNZ     WK1 
        RET 
WK1:    DEC     AH 
        JNZ     WK2 
        RET 
WK2:    DEC     AH                      ;? 
        JZ      READ_BLOCK              ; 
        DEC     AH                      ;? 
        JNZ     W2                      ; 
        JMP     WRITE_BLOCK             ;,  
 
W2: 
        DEC     AH 
        JNZ     W201 
        JMP     FILE_READ               ;  
W201:   DEC     AH 
        JNZ     W202 
        JMP     FILE_WRITE              ;  
W202: 
                                        ;  
        MOV     AH,080H                 ;   
        STC                             ;   
        RET 
W1      ENDP 
 
READ_BLOCK      PROC    NEAR 
;----------------------------------------------------------------------------- 
; : 
;    1   256-    
; 
;  : 
;   ES      
;   BX    
;   CX       
;  : 
;   BX        
;   CX     
;   DX    
; 
;    ,    
;      
;---------------------------------------------------------------------------- 
        PUSH    BX                      ; BX 
        PUSH    CX                      ; CX 
        PUSH    SI                      ; SI 
        MOV     SI,7                    ;    
W4:                                     ;  
        IN      AL,PORT_C               ;    . 
        AND     AL,010H ;   
        MOV     LAST_VAL,AL             ;    
        MOV     DX,16250                ;     
W5:                                     ;  
        CALL    BREAK_TEST              ; ? 
        JNZ     W6                      ; 
        JMP     W17                     ;  
 
W6:     DEC     DX 
        JNZ     W7                      ;,    
        JMP     W17                     ;,     
 
W7:     CALL    READ_HALF_BIT           ;   
        JCXZ    W5                      ;     . 
        IN      AL,021H ; .   
        OR      AL,1                    ;    
        OUT     021H,AL 
; 
        CALL    READ_HALF_BIT           ;  / 
        JCXZ    W4                      ; 
        MOV     DX,BX                   ; . . 
	CALL	READ_HALF_BIT		; . 2- / 
	JCXZ	W4			; 
	ADD	BX,DX			; .  
 
;  -----------       
 
	MOV	CX,100H	 ;    
W8: 
	CALL	BREAK_TEST		;? 
        JNZ     W117                    ; 
        JMP     W17                     ; 
W117:   XCHG    DX,BX                   ; . .  
        PUSH    CX 
; ----------------------------      
	CALL	READ_HALF_BIT		;  / 
        OR      CX,CX 
        POP     CX 
        JZ      W4 
        PUSH    CX 
	PUSH	BX			; .. / 
        CALL    READ_HALF_BIT           ;  . 
        OR      CX,CX 
	POP	AX			; AX  . . 
        POP     CX 
        JZ      W4 
	ADD	BX,AX			;BX <--- .   
	SUB	DX,BX			; .   .. 
	JNC	W801			;  , 
	NEG	DX			;   
W801:	CMP	DX,0C0H ;    
					;    
	JNC	W4			;   
 
	LOOP	W8			;,   
					; 256 (100H)  
 
;---    ,    
;      "1"  - . "1" 
 
        XCHG    DX,BX 
        MOV     CX,0FFH ;  
        XOR     AX,AX                   ;   
W88:    PUSH    CX                      ;  
        PUSH    AX                      ;   
        CALL    READ_HALF_BIT           ;   
        PUSH    BX                      ; . . 
        CALL    READ_HALF_BIT           ; . 2-  
        POP     AX                      ;  . 
        ADD     BX,AX                   ;   
        POP     AX                      ;   
        SUB     BX,DX                   ;   
        ADD     AX,BX                   ;   
        POP     CX                      ;  
        LOOP    W88 
; 
        MOV     CL,8 
        SAR     AX,CL                   ;   
        ADD     DX,AX                   ;DX <---  .  "1" P1 
        MOV     BX,DX 
        SAR     BX,1                    ;BX <--- P1/2 
        MOV     DX,BX 
        SAR     BX,1                    ;BX <--- P1/4 
        ADD     DX,BX                   ;DX <--- 0.75*P1 - MIN . .  
        MOV     LOWLIM,DX               ;. MIN . .  "1" 
        MOV     DX,BX 
        SAR     BX,1                    ;BX <--- P1/8 
        ADD     DX,BX                   ;DX <--- 3/8 * P1 - MIN .  
                                        ; "1"   - 
; 
;                                "0" - - 
W89: 
        CALL    BREAK_TEST              ;  
        JZ      W17                     ; 
        CALL    READ_HALF_BIT           ; .   
        CMP     DX,BX                   ;"0"  "1"? 
        JC      W89                     ; "1" -  
; 
;   - .  : 
        CALL    READ_HALF_BIT           ; 2-  - 
        CALL    READ_BYTE               ;  
        CMP     AL,16H                  ; - 
        JNE     W16                     ;,    
 
;------  .    
        POP     SI                      ;  
        POP     CX 
        POP     BX 
 
;------------------------------------------------------------------------- 
;  1   256-     
; 
; : 
; ES -          
; BX -     
; CX -       
; : 
; BX -     ,     
; CX -     
; DX -     
;--------------------------------------------------------------------------- 
        PUSH    CX                      ;   
W10:                                    ;    
                                        ;  256-  
        MOV     CRC_REG,0FFFFH          ; CRC- 
        MOV     DX,256                  ;DX <---    
W11:                                    ;  
        CALL    BREAK_TEST              ; ? 
        JZ      W13                     ; 
        CALL    READ_BYTE               ;  
        JC      W13                     ;  - CY=1 
        JCXZ    W12                     ;    (CX), 
                                        ; ,    
                                        ;  
        MOV     ES:[BX],AL              ;    
        INC     BX                      ;   
        DEC     CX                      ;   
W12:                    ;   256-   
        DEC     DX                      ;     
        JG      W11                     ;  ,  < 256 
        CALL    READ_BYTE               ;    CRC 
        CALL    READ_BYTE 
        SUB     AH,AH                   ; AH 
        CMP     CRC_REG,1D0FH           ;CRC ? 
        JNE     W14                     ;,   
        JCXZ    W15                     ;  =0, .. 
                                        ;  , 
                                        ;  
        JMP     W10                     ;  -    
                                ;   
W13:                                    ;  
        MOV     AH,01H                  ;   AH=02 - 
                                        ;" " 
W14:                                    ; CRC- 
        INC     AH                      ;   AH=01 - 
                                        ;" CRC-" 
W15:                                    ;  
        POP     DX                      ;   
        SUB     DX,CX                   ;  
                                        ;   . DX 
        PUSH    AX                      ; AX ( ) 
        TEST    AH,03H                  ; ? 
        JNZ     W18                     ;   
        CALL    READ_BYTE               ;  
        JMP     SHORT W18               ;   
W16:                                    ;  
        DEC     SI                      ;    
                                        ;  
        JZ      W17                     ;    
        JMP     W4                      ;   
W17:                                    ;   
;-------    ,..    
 
        POP     SI                      ;  
        POP     CX 
        POP     BX 
        SUB     DX,DX                   ;   
        MOV     AH,04H                  ; "  " 
        PUSH    AX 
W18: 
        IN      AL,021H         ;  
        AND     AL,0FFH-1 
        OUT     021H,AL 
        POP     AX                      ;   
        CMP     AH,01H                  ; CY=1   (AH>0) 
        CMC 
        RET                             ; 
READ_BLOCK      ENDP 
;--------------------------------------------------------------------------- 
READ_BYTE       PROC NEAR 
; : 
;      
;     AL     
;--------------------------------------------------------------------------- 
        PUSH    BX                      ;  BX,CX 
        PUSH    CX 
        MOV     CL,8H                   ;    8 
W19:                                    ;  
        PUSH    CX                      ;   
 
;---------------------------------------------------------------------------- 
;       
;---------------------------------------------------------------------------- 
        CALL    READ_HALF_BIT           ;   
        JCXZ    W21                     ; CX=0 - - 
                                        ;    
        PUSH    BX                      ;  
                                        ; (IN BX) 
        CALL    READ_HALF_BIT           ;   
        POP     AX                      ; . . . 
        JCXZ    W21                     ; CX=0 - - 
        ADD     BX,AX                   ;   
        CMP     BX,LOWLIM               ; "0"  "1" 
        CMC                             ;CY=1,    
        LAHF                            ;    AH 
        POP     CX                      ;   
                                        ; : 
                                        ;    
                                        ;. CH    
                                        ;     
                                        ; CH. 
                                        ;   8  
                                        ;    
                                        ;    . CH 
        RCL     CH,1                    ; . CH    
                                        ;    . CH 
        SAHF                            ; CY   CRC 
        CALL    CRC_GEN         ; CRC    
        DEC     CL                      ;   
                                        ;     - 
        JNZ     W19                     ;  8. 
        MOV     AL,CH                   ;AL <---   
        CLC 
W20:                                    ;   
        POP     CX                      ; . CX,BX 
        POP     BX 
        RET                             ; 
W21:                                    ;  
        POP     CX                      ; CX 
        STC                             ;   
        JMP     W20                     ;  
READ_BYTE       ENDP 
 
;-------------------------------------------------------------------------- 
WRITE_BLOCK     PROC    NEAR 
; 
;  1   256-   . 
;                256. 
; 
;  : 
;  BX -     
;  CX -     
; 
;  : 
;  BX   ,      
;  CX   
;--------------------------------------------------------------------------- 
        PUSH    BX 
        PUSH    CX 
        IN      AL,PORT_B               ;  
        AND     AL,NOT 02H 
        OR      AL,01H                  ;  2   
        OUT     PORT_B,AL 
        MOV     AL,0B6H          ; 2    3 
        OUT     TIM_CTL,AL 
        MOV     AX,1184  ;.    "1" 
        CALL    W31                     ;  
        MOV     CX,0800H                ;    
W23:                                    ;  
        STC                             ;  "1" 
        CALL    WRITE_BIT               ; 
        LOOP    W23                     ;  ? 
        CLC                             ; - (0) 
        CALL    WRITE_BIT 
        POP     CX                      ; CX,BX 
        POP     BX 
        MOV     AL,16H                  ; - 
        CALL    WRITE_BYTE              ; 
 
;------------------------------------------------------------------------- 
;  1   256-   . 
; 
;  : 
;  BX -     
;  CX -     
; 
;  : 
;  BX   ,      
;  CX   
; 
;--------------------------------------------------------------------------- 
WR_BLOCK: 
        MOV     CRC_REG,0FFFFH          ; CRC- 
        MOV     DX,256                  ;    
W24:                                    ;WR-BLK 
        MOV     AL,ES:[BX]              ;    
        CALL    WRITE_BYTE              ;    
        JCXZ    W25                     ; CX=0,   . 
        INC     BX                      ;INC    
        DEC     CX                      ;DEC    
W25:                                    ;SKIP-ADV 
        DEC     DX                      ;DEC    
        JG      W24                     ;  256   ? 
 
;---------------------- CRC------------------------------------------- 
;    CRC-  . 
;         CRC 
; 
;   AX 
;----------------------------------------------------------------------------- 
        MOV     AX,CRC_REG              ;   CRC- 
                                        ;    CRC   
        NOT     AX                      ;   
        PUSH    AX                      ;  
        XCHG    AH,AL                   ;    
        CALL    WRITE_BYTE              ;  
        POP     AX                      ;   
        CALL    WRITE_BYTE              ;  
        OR      CX,CX                   ;  ? 
        JNZ     WR_BLOCK                ;   
        PUSH    CX                      ; CX 
        MOV     CX,32                   ;   
W26:                                    ;    
        STC 
        CALL    WRITE_BIT 
        LOOP    W26                     ;    
        POP     CX                      ; CX 
	MOV	AL,0B0H		;   
        OUT     TIM_CTL,AL 
        MOV     AX,1 
        CALL    W31 
        IN      AL,PORT_B 
        AND     AL,NOT 01H 
        OUT     PORT_B,AL 
        SUB     AX,AX                   ;   
        RET                             ; 
WRITE_BLOCK     ENDP 
 
 
                ORG     0FA6EH 
 
